package net.t2code.t2codelib.SPIGOT.system;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.system.CreateReportLog;
import net.t2code.t2codelib.SPIGOT.system.config.config.SelectLibConfig;
import net.t2code.t2codelib.Util;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class CmdExecuter implements CommandExecutor, TabCompleter {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!sender.hasPermission("t2code.admin")) {
            T2Csend.sender(sender, "§4No Permission §8t2code.admin");
            return false;
        }
        if (args.length == 0) {
            T2Ctemplate.sendInfo(sender,T2CodeLibMain.getPlugin(), Util.getSpigotID(),Util.getDiscord(),null, Util.getInfoText());
            return false;
        }
        switch (args[0].toLowerCase()) {
            case "info":
            case "plugin":
            case "pl":
            case "version":
            case "ver":
                T2Ctemplate.sendInfo(sender,T2CodeLibMain.getPlugin(), Util.getSpigotID(),Util.getDiscord(),null, Util.getInfoText());
                return false;
            case "reloadconfig":
                SelectLibConfig.onSelect();
                return false;
            case "debug":
                if (args.length != 2) {
                    T2Csend.sender(sender, "§4Use: §7/t2code debug createReportLog");
                    return false;
                }
                if ("createreportlog".equals(args[1].toLowerCase())) {
                    Bukkit.getScheduler().runTaskAsynchronously(T2CodeLibMain.getPlugin(), new Runnable() {
                        @Override
                        public void run() {
                            CreateReportLog.create(sender);
                        }
                    });
                } else T2Csend.sender(sender, "§4Use: §7/t2code debug createReportLog");
                return false;

            default:
                T2Csend.sender(sender, "§4Use: §7/t2code debug createReportLog");
                return false;
        }
    }

    //TabCompleter
    private static HashMap<String, String> arg1 = new HashMap<String, String>() {{
        put("debug", "t2code.admin");
        put("info", "t2code.admin");
        put("reloadconfig", "t2code.admin");
    }};

    @Override
    public List<String> onTabComplete(CommandSender sender, Command cmd, String s, String[] args) {
        List<String> list = new ArrayList<>();
        if (sender instanceof Player) {
            Player p = (Player) sender;
            if (args.length == 1) {
                for (String command : arg1.keySet()) {
                    if (hasPermission(p, arg1.get(command)) && passend(command, args[0])) {
                        list.add(command);
                    }
                }
            }

            if (args.length == 2 && args[0].equalsIgnoreCase("debug")) {
                if (sender.hasPermission("t2code.admin")) {
                    if (hasPermission(p, arg1.get("debug")) && passend("debug", args[1])) {
                        list.add("createReportLog");
                    }
                }
                return list;
            }

        }
        return list;
    }

    private static Boolean passend(String command, String arg) {
        for (int i = 0; i < arg.toUpperCase().length(); i++) {
            if (arg.toUpperCase().length() >= command.toUpperCase().length()) {
                return false;
            } else {
                if (arg.toUpperCase().charAt(i) != command.toUpperCase().charAt(i)) {
                    return false;
                }
            }
        }
        return true;
    }

    public static boolean hasPermission(Player player, String permission) {
        if (player.isOp()) {
            return true;
        }
        String[] Permissions = permission.split(";");
        for (String perm : Permissions) {
            if (player.hasPermission(perm)) {
                return true;
            }
        }
        return false;
    }
}
